#293 Nginx & Unicorn pro
Oct 24, 2011 | 19 minutes | Tools, Production
Nginx and Unicorn make a killer-combo for hosting a Rails application in production. Learn how to configure each in a Vagrant virtual machine in this episode.
- Download:
- source codeProject Files in Zip (47.9 KB)
- mp4Full Size H.264 Video (57.9 MB)
- m4vSmaller H.264 Video (25.5 MB)
- webmFull Size VP8 Video (25.4 MB)
- ogvFull Size Theora Video (61.4 MB)
Resources
- Nginx Wiki
- Nginx TextMate Bundle
- Unicorn
- Unicorn Example Configs
- Unicorn on GitHub
- Everything You Need to Know About Unicorn
- I Like Unicorn Because It's Unix
Gemfile
gem 'unicorn'
Vagrantfile
config.vm.forward_port "http", 80, 8080
bash
# setup nginx sudo apt-get install nginx nginx -h cat /etc/init.d/nginx /etc/init.d/nginx -h sudo service nginx start cd /etc/nginx less nginx.conf cd sites-enabled sudo rm default sudo ln -s /vagrant/config/nginx.conf todo sudo service nginx restart # setup unicorn cd /vagrant bundle install bundle exec unicorn -c config/unicorn.rb -D chmod +x config/unicorn_init.sh sudo ln -s /vagrant/config/unicorn_init.sh /etc/init.d/unicorn bundle install --binstubs sudo service unicorn restart # rbenv binstubs fix rbenv local 1.9.2-p290 sed -i 's/env ruby/env ruby-local-exec/' bin/*
config/nginx.conf
upstream unicorn { server unix:/tmp/unicorn.todo.sock fail_timeout=0; } server { listen 80 default deferred; # server_name example.com; root /vagrant/public; try_files $uri/index.html $uri @unicorn; location @unicorn { proxy_set_header X-Forwarded-For $proxy_add_x_forwarded_for; proxy_set_header Host $http_host; proxy_redirect off; proxy_pass http://unicorn; } error_page 500 502 503 504 /500.html; client_max_body_size 4G; keepalive_timeout 10; }
config/unicorn.rb
working_directory "/vagrant" pid "/vagrant/tmp/pids/unicorn.pid" stderr_path "/vagrant/log/unicorn.log" stdout_path "/vagrant/log/unicorn.log" listen "/tmp/unicorn.todo.sock" worker_processes 2 timeout 30
config/unicorn_init.sh
#!/bin/sh set -e # Example init script, this can be used with nginx, too, # since nginx and unicorn accept the same signals # Feel free to change any of the following variables for your app: TIMEOUT=${TIMEOUT-60} APP_ROOT=/vagrant PID=$APP_ROOT/tmp/pids/unicorn.pid CMD="$APP_ROOT/bin/unicorn -D -c $APP_ROOT/config/unicorn.rb -E production" action="$1" set -u old_pid="$PID.oldbin" cd $APP_ROOT || exit 1 sig () { test -s "$PID" && kill -$1 `cat $PID` } oldsig () { test -s $old_pid && kill -$1 `cat $old_pid` } case $action in start) sig 0 && echo >&2 "Already running" && exit 0 su -c "$CMD" - vagrant ;; stop) sig QUIT && exit 0 echo >&2 "Not running" ;; force-stop) sig TERM && exit 0 echo >&2 "Not running" ;; restart|reload) sig HUP && echo reloaded OK && exit 0 echo >&2 "Couldn't reload, starting '$CMD' instead" su -c "$CMD" - vagrant ;; upgrade) if sig USR2 && sleep 2 && sig 0 && oldsig QUIT then n=$TIMEOUT while test -s $old_pid && test $n -ge 0 do printf '.' && sleep 1 && n=$(( $n - 1 )) done echo if test $n -lt 0 && test -s $old_pid then echo >&2 "$old_pid still exists after $TIMEOUT seconds" exit 1 fi exit 0 fi echo >&2 "Couldn't upgrade, starting '$CMD' instead" su -c "$CMD" - vagrant ;; reopen-logs) sig USR1 ;; *) echo >&2 "Usage: $0 <start|stop|restart|upgrade|force-stop|reopen-logs>" exit 1 ;; esac